<?php
header ("Content-type: image/png");

$coords = array ( 
		 "ccgridli03.in2p3.fr" => "325/740",
		 "ccgridli08.in2p3.fr" => "345/740",
		 "lxshare0227.cern.ch" => "350/685",
		 "lxshare0364.cern.ch" => "365/685",
		 "bfa.hep.ph.ic.ac.uk" => "220/585",
		 "gw39.hep.ph.ic.ac.uk" => "235/585",
		 "testbed008.cnaf.infn.it" => "435/770",
		 "gtk-pkinit.cnaf.infn.it" => "420/770",
		 "grid001.pd.infn.it" => "425/705",
		 "cmsgrid001.lnl.infn.it" => "440/705",
		 "hepgrid2.ph.liv.ac.uk" => "200/525",
		 "polgrid1.in2p3.fr" => "279/634",
		 "gf16.hep.man.ac.uk" => "230/485",
		 "gf18.hep.man.ac.uk" => "245/485",
		 "tbn09.nikhef.nl" => "330/555",
		 "tbce01.physics.ox.ac.uk" => "235/535",
		 "gppce05.gridpp.rl.ac.uk" => "245/535"
		 );

$host  = "lxshare0225.cern.ch";
$port  = 2170;
$bdn   = "mds-vo-name=local,o=grid";

$celim  = array( "dn", 
		 "ceid",
		 "totalcpus", 
		 "freecpus"
		 );
$cefilstr = "(objectclass=ComputingElement)";

$cedata   = array ();
$sitedata = array ();

$tstamp = date("Y-m-d T H:i:s");

$ds = ldap_connect($host,$port);
if ( $ds ) {
  $ceres = ldap_search($ds,$bdn,$cefilstr,$celim);
  if ( $ceres ) $cedata = ldap_get_entries($ds,$ceres);
  ldap_free_result($ceres);
  $nces = $cedata["count"];
  for ( $i = 0; $i < $nces; $i++ ) {
    $curce   = $cedata[$i]["ceid"][0];
    $ceparts = explode(":",$curce);
    $site    = $ceparts[0];
    $totcpu  = $cedata[$i]["totalcpus"][0];
    $freecpu = $cedata[$i]["freecpus"][0];
    $sitedata[$site][] = $totcpu."/".$freecpu;
  }
}


$im = @imagecreatefrompng ("europe-cia-edg.png");

$background = imagecolorallocate ($im, 255, 255, 255);
$bcol       = imagecolorallocate ($im, 0,0,0);
$tcol       = imagecolorallocate ($im, 204,0,0);
$fcol       = imagecolorallocate ($im, 0,204,0);
$gcol       = imagecolorallocate ($im, 102,102,102);
//$trans      = imagecolortransparent($im,$background);
foreach ( $sitedata as $sitename => $sitestat ) {
  $sitecoor = explode("/",$coords[$sitename]);
  $x    = $sitecoor[0];
  $y    = $sitecoor[1];
  $cput = 0;
  $cpuf = 0;
  $frac = 0;
  foreach ( $sitestat as $queue ) {
    $cpus = explode("/",$queue);
    $tot  = $cpus[0];
    $free = $cpus[1];
    if ( $tot  != $cput ) $cput += $tot;
    if ( $free != $cpuf ) $cpuf += $free;
  }
  //  echo "$sitename: $cput / $cpuf<br>";
  if ( $cput != 0 ) $frac = $cpuf/$cput;
  $a1   = ceil($frac*360);
  $a2   = 360-$a1;
  $r    = 10;
  if ( $cput > 9 )  $r=15;
  if ( $cput > 99 ) $r=20;
  imagefilledarc ($im, $x, $y, $r, $r, 0,   $a1,  $fcol, IMG_ARC_PIE);
  imagefilledarc ($im, $x, $y, $r, $r, $a1, 360 , $gcol, IMG_ARC_PIE);  
  //  imagestring ($im, 1, $x, $x+$y-500, "$sitename: $cput/$cpuf", $bcol);
}

// Legend

imagestring ($im, 5, 10, 280, "EDG Applications Testbed status", $bcol);
imagestring ($im, 4, 10, 300, $tstamp, $bcol);

imagefilledarc ($im, 20, 335, 10, 10, 0, 360, $fcol, IMG_ARC_PIE);
imagestring ($im, 3, 35, 330, " < 10 CPUs", $bcol);
imagefilledarc ($im, 20, 360, 15, 15, 0, 360, $fcol, IMG_ARC_PIE);
imagestring ($im, 3, 35, 355, " 10 - 100 CPUs", $bcol);
imagefilledarc ($im, 20, 385, 20, 20, 0, 360, $fcol, IMG_ARC_PIE);
imagestring ($im, 3, 35, 380, " > 100 CPUs", $bcol);

imagefilledarc ($im, 20, 415, 20, 20, 0, 270, $fcol, IMG_ARC_PIE);
imagestring ($im, 2, 35, 410, "free", $bcol);
imagefilledarc ($im, 80, 415, 20, 20, 0, 270, $gcol, IMG_ARC_PIE);
imagestring ($im, 2, 95, 410, "busy", $bcol);

imagepng ($im);
ImageDestroy($im);
?>
